{% extends 'base.html' %} {% block content %} {% load static %}
{% load humanize %}
{% load crispy_forms_tags %}
<div class="d-flex flex-column px-4 py-3">
    {% if success %}
    <div class="alert alert-success" role="alert">
    {{action}} Saved!
    </div>
    {% endif %}
  <div class="d-flex flex-column" id="product">
    <div class="image-card">
      <img src="{{barang.gambar}}" class="product-image" />
    </div>
    <div class="product-description px-3 pt-3">
      <h1>{{barang.nama}}</h3>
        <div class="product-detail px-2">
      <h6 class="text-muted">{{barang.kategori.nama}} | {{barang.stok}} pcs</h4>
        <span class="product-price">Rp. {{barang.harga|intcomma}}</span>
      <p class="text-justify">{{barang.deskripsi}}</p>
      {% if user.is_authenticated %}
      <button class="btn btn-primary btn-buy" data-toggle="modal" data-target="#modalBuy">Buy</button>
      <button class="btn btn-primary" id="btn-cart">Add to Cart</button>
      {% endif %}
    </div>
    </div>
  </div>
  <div class="online-card mt-3" id="ulasan-card">
    <div class="d-flex justify-content-center flex-wrap" id="rating-header">
        <h3>ULASAN</h3>
        <div class="d-flex align-items-center px-2">
            <div id="rating-top" data-rateyo-read-only="true" data-rateyo-half-star="true" data-rateyo-rating="{{avg_rating}}"></div>({{num_rating}})
        </div>
    </div>
    <hr>
    <div id="ulasan-container">
        {% if ulasan_barang|length > 0 %}
            <div class="accordion" id="ulasan-accordion">
                {% for ulasan in ulasan_barang %}
                  <div class="card">
                    <div class="card-header" id="heading{{ulasan.id}}">
                    <div class="d-flex justify-content-between align-items-center" data-toggle="collapse" data-target="#collapse{{ulasan.id}}" aria-expanded="false" aria-controls="collapse{{ulasan.id}}">
                      <div class="d-flex">
                      <h4 class="mb-0">
                            {{ulasan.nama_pengulas}}
                        </h4>
                        <button class="btn-delete" data-id={{ulasan.id}}>Delete</button>
                        </div>  
                        <div class="d-flex justify-content-center align-items-center">
                            <div class="rating-ind d-none d-md-block" data-rateyo-read-only="true" data-rateyo-rating={{ulasan.bintang}}></div>
                        </div>
                    </div>
                    </div>

                    <div id="collapse{{ulasan.id}}" class="collapse
                    {% if forloop.counter == 1%}
                    show
                    {% endif %}
                    " aria-labelledby="heading{{ulasan.id}}" data-parent="#ulasan-accordion">
                    <div class="card-body">
                        {{ ulasan.pesan }}
                    </div>
                    </div>
                </div>
                {% endfor %}
            </div>
        {% else %}
        <div class="text-center">
            Tidak ada ulasan!
        </div> 
        {% endif %}
        <div class="d-flex justify-content-center mt-3">
      <button class="btn btn-primary btn-buy" data-toggle="modal" data-target="#modalUlasan">Add Review</button>
        </div>
    </div>
  </div>
</div>
<div class="modal fade" id="modalBuy" tabindex="-1" role="dialog" aria-labelledby="modalBuy" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="modalBuyLabel">Buy {{barang.nama}}</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
                <form action="{% url 'barang:barang-buy' id=barang.id %}" method="POST">
      <div class="modal-body">
              {% csrf_token %}
              {{beli_form|crispy}} 
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <button type="submit" class="btn btn-primary">Buy</button>
      </div>
      </form>
    </div>
  </div>
</div>
<div class="modal fade" id="modalUlasan" tabindex="-1" role="dialog" aria-labelledby="modalBuy" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h5 class="modal-title" id="modalUlasanLabel">Add Review for {{barang.nama}}</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
                <form id="ulasan-form">
      <div class="modal-body">
              {% csrf_token %}
              {{ulasan_form|crispy}} 
      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <button type="submit" class="btn btn-primary">Add</button>
      </div>
      </form>
    </div>
  </div>
</div>
{% endblock %} {% block head %}
<title> {{barang.nama}} | Tk.PePeW Online Shop</title>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/rateYo/2.3.2/jquery.rateyo.min.css">
<link rel="stylesheet" href="{% static 'barang/styles.css' %}" />

{% endblock %}{% block leftsidecontent %}
{% endblock %} {% block rightsidecontent %} {% include 'includes/recommended.html' %} {% endblock %}

{% block js %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/rateYo/2.3.2/jquery.rateyo.min.js"></script>
<script>

function updateUlasan(ulasans) {
  const accordionUlasanHTMLString = (ulasan) => (`
    <div class="card">
        <div class="card-header" id="heading${ulasan.id}">
        <div class="d-flex justify-content-between align-items-center" data-toggle="collapse" data-target="#collapse${ulasan.id}" aria-expanded="false" aria-controls="collapse${ulasan.id}">
                      <div class="d-flex">
                      <h4 class="mb-0">
                            ${ulasan.nama_pengulas}
                        </h4>
                        <button class="btn-delete" data-id=${ulasan.id}>Delete</button>
                        </div>  
            <div class="d-flex justify-content-center align-items-center">
                <div class="rating-ind d-none d-md-block" data-rateyo-read-only="true" data-rateyo-rating=${ulasan.bintang}></div>
            </div>
        </div>
        </div>

        <div id="collapse${ulasan.id}" class="collapse" aria-labelledby="heading${ulasan.id}" data-parent="#ulasan-accordion">
        <div class="card-body">
            ${ ulasan.pesan }
        </div>
        </div>
    </div>
  `)

  const ulasansString = `
    <div class="accordion" id="ulasan-accordion">
      ${ulasans.map(accordionUlasanHTMLString).join("")}
    </div>
  `

  $("#ulasan-container").html(ulasansString)

    $(".rating-ind").rateYo({
    starWidth: "18px"
  });
}

$(function () {
  $("#rating-top").rateYo({
    starWidth: "18px"
  });
  $(".rating-ind").rateYo({
    starWidth: "18px"
  });

  $("#btn-cart").click(async () => {
    const user_id = `{{user.id}}`;
    const barang_id = `{{barang.id}}`;

    const data = {
      user_id,
      barang_id
    }

    const csrftoken = Cookies.get('csrftoken');
    const response = await fetch(`{% url 'keranjang:add' %}`, {
      method: 'POST',
      body: JSON.stringify(data),
      headers: { "X-CSRFToken": csrftoken },
    });

    const result = await response.json();

    const notyf = new Notyf();
    if (result.success) {
      notyf.success(`Barang telah ditambhkan ke keranjang!`);
    } else {
      notyf.error(`Barang gagal ditambahkan ke keranjang!`);
      notyf.error(result.error);
    }
    
  });

    $("#ulasan-form").submit(async (e) => {
      e.preventDefault();
      const f = e.target
      const nama_pengulas = f.nama_pengulas.value
      const bintang = f.bintang.value
      const pesan = f.pesan.value

      const barang_id = `{{barang.id}}`;

      $('#modalUlasan').modal('hide')

    const data = {
      nama_pengulas,
      bintang,
      pesan,
      barang_id
    }

    const csrftoken = Cookies.get('csrftoken');
    const response = await fetch(`{% url 'ulasan:add' %}`, {
      method: 'POST',
      body: JSON.stringify(data),
      headers: { "X-CSRFToken": csrftoken },
    });

    const result = await response.json();

    const notyf = new Notyf();
    if (result.success) {
      notyf.success(`Ulasan telah ditambahkan!`);
      updateUlasan(result.ulasan);
    } else {
      notyf.error(`Ulasan gagal ditambahkan!`);
      notyf.error(result.error);
    }
    
  });

  $(".btn-delete").click(async function() {
      const ulasan_id = this.dataset.id;

    const data = {
      ulasan_id
    }

    const csrftoken = Cookies.get('csrftoken');
    const response = await fetch(`{% url 'ulasan:delete' %}`, {
      method: 'POST',
      body: JSON.stringify(data),
      headers: { "X-CSRFToken": csrftoken },
    });

    const result = await response.json();

    const notyf = new Notyf();
    if (result.success) {
      notyf.success(`Ulasan telah diremove!`);
      updateUlasan(result.ulasan);
    } else {
      notyf.error(`Ulasan gagal diremove!`);
      notyf.error(result.error);
    }
    
  });
});
</script>
{% if success is not None and not success %}
{% if 'Transaction' == action %}
<script>
    $(function() {
        $("#modalBuy").modal()
    })
</script>
{% else %}
<script>
    $(function() {
        $("#modalUlasan").modal()
    })
</script>
{% endif %}
{% endif %}
{% endblock %}